diff --git a/SOURCES/kmod-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch b/SOURCES/kmod-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch
new file mode 100644
index 0000000..717c678
--- /dev/null
+++ b/SOURCES/kmod-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch
@@ -0,0 +1,43 @@
+From 1f5010924500a4fd83047584d1fbdba5517dffa2 Mon Sep 17 00:00:00 2001
+From: Tony Camuso <tcamuso@redhat.com>
+Date: Fri, 24 Jun 2016 12:37:48 -0400
+Subject: [RHEL-7.3 PATCH 1/3] depmod: Don't fall back to uname on bad version
+
+Cherry-picked without conflicts from the following upstream commit.
+
+commit f3f62f5ec3b23823b2ce02e37bc707dc85c56461
+Author: Laura Abbott <labbott@fedoraproject.org>
+Date:   Mon Sep 28 15:39:14 2015 -0700
+
+    depmod: Don't fall back to uname on bad version
+
+    Currently, if a value that doesn't match a kernel version
+    ("%u.%u") is passed in, depmod silently falls back to
+    using uname. Rather than try and work around the caller passing
+    bad data, just exit out instead.
+
+Signed-off-by: Tony Camuso <tcamuso@redhat.com>
+---
+ tools/depmod.c | 6 +++++-
+ 1 file changed, 5 insertions(+), 1 deletion(-)
+
+diff --git a/tools/depmod.c b/tools/depmod.c
+index 231b9ab..8d5c671 100644
+--- a/tools/depmod.c
++++ b/tools/depmod.c
+@@ -2475,7 +2475,11 @@ static int do_depmod(int argc, char *argv[])
+ 		}
+ 	}
+ 
+-	if (optind < argc && is_version_number(argv[optind])) {
++	if (optind < argc) {
++		if (!is_version_number(argv[optind])) {
++			ERR("Bad version passed %s\n", argv[optind]);
++			goto cmdline_failed;
++		}
+ 		cfg.kversion = argv[optind];
+ 		optind++;
+ 	} else {
+-- 
+1.8.3.1
+
diff --git a/SOURCES/kmod-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch b/SOURCES/kmod-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch
new file mode 100644
index 0000000..70a9900
--- /dev/null
+++ b/SOURCES/kmod-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch
@@ -0,0 +1,40 @@
+From 6708fbf7d26c6241cc37614c632bba1ce4ef1a4e Mon Sep 17 00:00:00 2001
+From: Tony Camuso <tcamuso@redhat.com>
+Date: Fri, 24 Jun 2016 12:38:25 -0400
+Subject: [RHEL-7.3 PATCH 2/3] depmod: Ignore PowerPC64 ABIv2 .TOC. symbol
+
+Cherry-picked without conflicts from the following upstream commit.
+
+commit d46136bb59c46609ee8050636f0681f2831d2225
+Author: Anton Blanchard <anton@samba.org>
+Date:   Fri Jun 10 15:24:30 2016 +1000
+
+    depmod: Ignore PowerPC64 ABIv2 .TOC. symbol
+
+    The .TOC. symbol on the PowerPC64 ABIv2 identifies the GOT
+    pointer, similar to how other architectures use _GLOBAL_OFFSET_TABLE_.
+
+    This is not a symbol that needs relocation, and should be ignored
+    by depmod.
+
+Signed-off-by: Tony Camuso <tcamuso@redhat.com>
+---
+ tools/depmod.c | 2 ++
+ 1 file changed, 2 insertions(+)
+
+diff --git a/tools/depmod.c b/tools/depmod.c
+index 8d5c671..7b95832 100644
+--- a/tools/depmod.c
++++ b/tools/depmod.c
+@@ -2149,6 +2149,8 @@ static void depmod_add_fake_syms(struct depmod *depmod)
+ 	depmod_symbol_add(depmod, "__this_module", true, 0, NULL);
+ 	/* On S390, this is faked up too */
+ 	depmod_symbol_add(depmod, "_GLOBAL_OFFSET_TABLE_", true, 0, NULL);
++	/* On PowerPC64 ABIv2, .TOC. is more or less _GLOBAL_OFFSET_TABLE_ */
++	depmod_symbol_add(depmod, "TOC.", true, 0, NULL);
+ }
+ 
+ static int depmod_load_symvers(struct depmod *depmod, const char *filename)
+-- 
+1.8.3.1
+
diff --git a/SOURCES/kmod-0003-libkmod-Handle-long-lines-in-proc-modules.patch b/SOURCES/kmod-0003-libkmod-Handle-long-lines-in-proc-modules.patch
new file mode 100644
index 0000000..7d41e1a
--- /dev/null
+++ b/SOURCES/kmod-0003-libkmod-Handle-long-lines-in-proc-modules.patch
@@ -0,0 +1,89 @@
+From 22dadafa9fa961fa70cc616679b8b24689382348 Mon Sep 17 00:00:00 2001
+From: Tony Camuso <tcamuso@redhat.com>
+Date: Fri, 24 Jun 2016 12:38:52 -0400
+Subject: [RHEL-7.3 PATCH 3/3] libkmod: Handle long lines in /proc/modules
+
+Cherry-picked without conflicts from the following upstream commit.
+
+commit 2206d7f763a1c9cf88f77d0ab19e410d17749361
+Author: Michal Marek <mmarek@suse.cz>
+Date:   Fri Jun 17 16:04:15 2016 +0200
+
+    libkmod: Handle long lines in /proc/modules
+
+    kmod_module_new_from_loaded() calls fgets with a 4k buffer. When a
+    module such as usbcore is used by too many modules, the rest of the line
+    is considered a beginning of another lines and we eventually get errors
+    like these from lsmod:
+
+    libkmod: kmod_module_get_holders: could not open '/sys/module/100,/holders': No such file or directory
+
+    together with bogus entries in the output. In kmod_module_get_size, the
+    problem does not affect functionality, but the line numbers in error
+    messages will be wrong.
+
+    Signed-off-by: Michal Marek <mmarek@suse.com>
+
+Signed-off-by: Tony Camuso <tcamuso@redhat.com>
+---
+ libkmod/libkmod-module.c | 12 ++++++++++--
+ 1 file changed, 10 insertions(+), 2 deletions(-)
+
+diff --git a/libkmod/libkmod-module.c b/libkmod/libkmod-module.c
+index 366308f..47bb880 100644
+--- a/libkmod/libkmod-module.c
++++ b/libkmod/libkmod-module.c
+@@ -1660,13 +1660,14 @@ KMOD_EXPORT int kmod_module_new_from_loaded(struct kmod_ctx *ctx,
+ 		struct kmod_module *m;
+ 		struct kmod_list *node;
+ 		int err;
++		size_t len = strlen(line);
+ 		char *saveptr, *name = strtok_r(line, " \t", &saveptr);
+ 
+ 		err = kmod_module_new_from_name(ctx, name, &m);
+ 		if (err < 0) {
+ 			ERR(ctx, "could not get module from name '%s': %s\n",
+ 				name, strerror(-err));
+-			continue;
++			goto eat_line;
+ 		}
+ 
+ 		node = kmod_list_append(l, m);
+@@ -1676,6 +1677,9 @@ KMOD_EXPORT int kmod_module_new_from_loaded(struct kmod_ctx *ctx,
+ 			ERR(ctx, "out of memory\n");
+ 			kmod_module_unref(m);
+ 		}
++eat_line:
++		while (line[len - 1] != '\n' && fgets(line, sizeof(line), fp))
++			len = strlen(line);
+ 	}
+ 
+ 	fclose(fp);
+@@ -1825,12 +1829,13 @@ KMOD_EXPORT long kmod_module_get_size(const struct kmod_module *mod)
+ 	}
+ 
+ 	while (fgets(line, sizeof(line), fp)) {
++		size_t len = strlen(line);
+ 		char *saveptr, *endptr, *tok = strtok_r(line, " \t", &saveptr);
+ 		long value;
+ 
+ 		lineno++;
+ 		if (tok == NULL || !streq(tok, mod->name))
+-			continue;
++			goto eat_line;
+ 
+ 		tok = strtok_r(NULL, " \t", &saveptr);
+ 		if (tok == NULL) {
+@@ -1848,6 +1853,9 @@ KMOD_EXPORT long kmod_module_get_size(const struct kmod_module *mod)
+ 
+ 		size = value;
+ 		break;
++eat_line:
++		while (line[len - 1] != '\n' && fgets(line, sizeof(line), fp))
++			len = strlen(line);
+ 	}
+ 	fclose(fp);
+ 
+-- 
+1.8.3.1
+
diff --git a/SOURCES/kmod-20-9.el7-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch b/SOURCES/kmod-20-9.el7-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch
deleted file mode 100644
index 717c678..0000000
--- a/SOURCES/kmod-20-9.el7-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch
+++ /dev/null
@@ -1,43 +0,0 @@
-From 1f5010924500a4fd83047584d1fbdba5517dffa2 Mon Sep 17 00:00:00 2001
-From: Tony Camuso <tcamuso@redhat.com>
-Date: Fri, 24 Jun 2016 12:37:48 -0400
-Subject: [RHEL-7.3 PATCH 1/3] depmod: Don't fall back to uname on bad version
-
-Cherry-picked without conflicts from the following upstream commit.
-
-commit f3f62f5ec3b23823b2ce02e37bc707dc85c56461
-Author: Laura Abbott <labbott@fedoraproject.org>
-Date:   Mon Sep 28 15:39:14 2015 -0700
-
-    depmod: Don't fall back to uname on bad version
-
-    Currently, if a value that doesn't match a kernel version
-    ("%u.%u") is passed in, depmod silently falls back to
-    using uname. Rather than try and work around the caller passing
-    bad data, just exit out instead.
-
-Signed-off-by: Tony Camuso <tcamuso@redhat.com>
----
- tools/depmod.c | 6 +++++-
- 1 file changed, 5 insertions(+), 1 deletion(-)
-
-diff --git a/tools/depmod.c b/tools/depmod.c
-index 231b9ab..8d5c671 100644
---- a/tools/depmod.c
-+++ b/tools/depmod.c
-@@ -2475,7 +2475,11 @@ static int do_depmod(int argc, char *argv[])
- 		}
- 	}
- 
--	if (optind < argc && is_version_number(argv[optind])) {
-+	if (optind < argc) {
-+		if (!is_version_number(argv[optind])) {
-+			ERR("Bad version passed %s\n", argv[optind]);
-+			goto cmdline_failed;
-+		}
- 		cfg.kversion = argv[optind];
- 		optind++;
- 	} else {
--- 
-1.8.3.1
-
diff --git a/SOURCES/kmod-20-9.el7-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch b/SOURCES/kmod-20-9.el7-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch
deleted file mode 100644
index 70a9900..0000000
--- a/SOURCES/kmod-20-9.el7-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch
+++ /dev/null
@@ -1,40 +0,0 @@
-From 6708fbf7d26c6241cc37614c632bba1ce4ef1a4e Mon Sep 17 00:00:00 2001
-From: Tony Camuso <tcamuso@redhat.com>
-Date: Fri, 24 Jun 2016 12:38:25 -0400
-Subject: [RHEL-7.3 PATCH 2/3] depmod: Ignore PowerPC64 ABIv2 .TOC. symbol
-
-Cherry-picked without conflicts from the following upstream commit.
-
-commit d46136bb59c46609ee8050636f0681f2831d2225
-Author: Anton Blanchard <anton@samba.org>
-Date:   Fri Jun 10 15:24:30 2016 +1000
-
-    depmod: Ignore PowerPC64 ABIv2 .TOC. symbol
-
-    The .TOC. symbol on the PowerPC64 ABIv2 identifies the GOT
-    pointer, similar to how other architectures use _GLOBAL_OFFSET_TABLE_.
-
-    This is not a symbol that needs relocation, and should be ignored
-    by depmod.
-
-Signed-off-by: Tony Camuso <tcamuso@redhat.com>
----
- tools/depmod.c | 2 ++
- 1 file changed, 2 insertions(+)
-
-diff --git a/tools/depmod.c b/tools/depmod.c
-index 8d5c671..7b95832 100644
---- a/tools/depmod.c
-+++ b/tools/depmod.c
-@@ -2149,6 +2149,8 @@ static void depmod_add_fake_syms(struct depmod *depmod)
- 	depmod_symbol_add(depmod, "__this_module", true, 0, NULL);
- 	/* On S390, this is faked up too */
- 	depmod_symbol_add(depmod, "_GLOBAL_OFFSET_TABLE_", true, 0, NULL);
-+	/* On PowerPC64 ABIv2, .TOC. is more or less _GLOBAL_OFFSET_TABLE_ */
-+	depmod_symbol_add(depmod, "TOC.", true, 0, NULL);
- }
- 
- static int depmod_load_symvers(struct depmod *depmod, const char *filename)
--- 
-1.8.3.1
-
diff --git a/SOURCES/kmod-20-9.el7-0003-libkmod-Handle-long-lines-in-proc-modules.patch b/SOURCES/kmod-20-9.el7-0003-libkmod-Handle-long-lines-in-proc-modules.patch
deleted file mode 100644
index 7d41e1a..0000000
--- a/SOURCES/kmod-20-9.el7-0003-libkmod-Handle-long-lines-in-proc-modules.patch
+++ /dev/null
@@ -1,89 +0,0 @@
-From 22dadafa9fa961fa70cc616679b8b24689382348 Mon Sep 17 00:00:00 2001
-From: Tony Camuso <tcamuso@redhat.com>
-Date: Fri, 24 Jun 2016 12:38:52 -0400
-Subject: [RHEL-7.3 PATCH 3/3] libkmod: Handle long lines in /proc/modules
-
-Cherry-picked without conflicts from the following upstream commit.
-
-commit 2206d7f763a1c9cf88f77d0ab19e410d17749361
-Author: Michal Marek <mmarek@suse.cz>
-Date:   Fri Jun 17 16:04:15 2016 +0200
-
-    libkmod: Handle long lines in /proc/modules
-
-    kmod_module_new_from_loaded() calls fgets with a 4k buffer. When a
-    module such as usbcore is used by too many modules, the rest of the line
-    is considered a beginning of another lines and we eventually get errors
-    like these from lsmod:
-
-    libkmod: kmod_module_get_holders: could not open '/sys/module/100,/holders': No such file or directory
-
-    together with bogus entries in the output. In kmod_module_get_size, the
-    problem does not affect functionality, but the line numbers in error
-    messages will be wrong.
-
-    Signed-off-by: Michal Marek <mmarek@suse.com>
-
-Signed-off-by: Tony Camuso <tcamuso@redhat.com>
----
- libkmod/libkmod-module.c | 12 ++++++++++--
- 1 file changed, 10 insertions(+), 2 deletions(-)
-
-diff --git a/libkmod/libkmod-module.c b/libkmod/libkmod-module.c
-index 366308f..47bb880 100644
---- a/libkmod/libkmod-module.c
-+++ b/libkmod/libkmod-module.c
-@@ -1660,13 +1660,14 @@ KMOD_EXPORT int kmod_module_new_from_loaded(struct kmod_ctx *ctx,
- 		struct kmod_module *m;
- 		struct kmod_list *node;
- 		int err;
-+		size_t len = strlen(line);
- 		char *saveptr, *name = strtok_r(line, " \t", &saveptr);
- 
- 		err = kmod_module_new_from_name(ctx, name, &m);
- 		if (err < 0) {
- 			ERR(ctx, "could not get module from name '%s': %s\n",
- 				name, strerror(-err));
--			continue;
-+			goto eat_line;
- 		}
- 
- 		node = kmod_list_append(l, m);
-@@ -1676,6 +1677,9 @@ KMOD_EXPORT int kmod_module_new_from_loaded(struct kmod_ctx *ctx,
- 			ERR(ctx, "out of memory\n");
- 			kmod_module_unref(m);
- 		}
-+eat_line:
-+		while (line[len - 1] != '\n' && fgets(line, sizeof(line), fp))
-+			len = strlen(line);
- 	}
- 
- 	fclose(fp);
-@@ -1825,12 +1829,13 @@ KMOD_EXPORT long kmod_module_get_size(const struct kmod_module *mod)
- 	}
- 
- 	while (fgets(line, sizeof(line), fp)) {
-+		size_t len = strlen(line);
- 		char *saveptr, *endptr, *tok = strtok_r(line, " \t", &saveptr);
- 		long value;
- 
- 		lineno++;
- 		if (tok == NULL || !streq(tok, mod->name))
--			continue;
-+			goto eat_line;
- 
- 		tok = strtok_r(NULL, " \t", &saveptr);
- 		if (tok == NULL) {
-@@ -1848,6 +1853,9 @@ KMOD_EXPORT long kmod_module_get_size(const struct kmod_module *mod)
- 
- 		size = value;
- 		break;
-+eat_line:
-+		while (line[len - 1] != '\n' && fgets(line, sizeof(line), fp))
-+			len = strlen(line);
- 	}
- 	fclose(fp);
- 
--- 
-1.8.3.1
-
diff --git a/SOURCES/weak-modules b/SOURCES/weak-modules
index fe5050c..2ca97b2 100644
--- a/SOURCES/weak-modules
+++ b/SOURCES/weak-modules
@@ -3,6 +3,14 @@
 # weak-modules - determine which modules are kABI compatible with installed
 #                kernels and set up the symlinks in /lib/*/weak-updates.
 #
+# This is an updated version of the script which doesn't support
+# multiple installation of the same out-of-tree module (stored in the
+# 'extra' subdirectory) for multiple kernels. This assumption is
+# supposed to be verified at the rpm level of the packages delivering
+# these modules.  There are some checks for this assumption, however we
+# really don't solve this situation. This limitation allows for a much
+# simpler version of the script. Previous version tried to work in this
+# case but was incorrect in some cases.
 
 unset LANG LC_ALL LC_COLLATE
 
@@ -10,14 +18,13 @@ tmpdir=$(mktemp -td ${0##*/}.XXXXXX)
 trap "rm -rf $tmpdir" EXIT
 unset ${!changed_modules_*} ${!changed_initramfs_*}
 
-initramfs_prefix="/boot" # can customize here
+unset BASEDIR
+unset CHECK_INITRAMFS
+default_initramfs_prefix="/boot" # will be combined with BASEDIR
 dracut="/sbin/dracut"
-
-if [ ! -x "$dracut" ]
-then
-        echo "weak-modules: this tool requires a dracut-enabled kernel"
-	exit 1
-fi
+declare -a modules
+declare -A module_krels
+declare -A weak_modules_before
 
 # doit:
 # A wrapper used whenever we're going to perform a real operation.
@@ -26,29 +33,69 @@ doit() {
     [ -n "$dry_run" ] || "$@"
 }
 
+# pr_verbose:
+# print verbose -- wrapper used to print extra messages if required
+pr_verbose() {
+    [ -n "$verbose" ] && echo "$@"
+}
+
+# pr_warning:
+# print warning
+pr_warning() {
+    echo "WARNING: $*"
+}
+
 # rpmsort: The sort in coreutils can't sort the RPM list how we want it so we
 # instead transform the list into a form it will sort correctly, then sort.
 rpmsort() {
-	local IFS=$' '
-	REVERSE=""
-	rpmlist=($(cat))
+    local IFS=$' '
+    REVERSE=""
+    rpmlist=($(cat))
+
+    if [ "-r" == "$1" ];
+    then
+        REVERSE="-r"
+    fi
+
+    echo ${rpmlist[@]} | \
+        sed -e 's/-/../g' | \
+        sort ${REVERSE} -n -t"." -k1,1 -k2,2 -k3,3 -k4,4 -k5,5 -k6,6 -k7,7 \
+             -k8,8 -k9,9 -k10,10 | \
+        sed -e 's/\.\./-/g'
+}
+
+# krel_of_module:
+# Compute the kernel release of a module.
+krel_of_module() {
+    local module="$1"
 
-	if [ "-r" == "$1" ];
-	then
-		REVERSE="-r"
-	fi
+    if [ x"${module_krels[$module]+set}" = x"set" ]; then
+        # version cached in the array already
+        echo "${module_krels[$module]}"
+    elif [ -f "$module" ]; then
+        krel_of_module_modinfo "$module"
+    else
+        # Try to extract the kernel release from the path
+        # delete case, the .ko already deleted
+        set -- "${module#*/lib/modules/}"
+        echo "${1%%/*}"
+    fi
+}
 
-	echo ${rpmlist[@]} | \
-	sed -e 's/-/../g' | \
-	sort ${REVERSE} -n -t"." -k1,1 -k2,2 -k3,3 -k4,4 -k5,5 -k6,6 -k7,7 \
-				 -k8,8 -k9,9 -k10,10 | \
-	sed -e 's/\.\./-/g'
+# krel_of_module_modinfo:
+# Fetches module version from internal module info
+krel_of_module_modinfo() {
+    local module="$1"
+    /sbin/modinfo -F vermagic "$module" | awk '{print $1}'
 }
 
 # read_modules_list:
 # Read in a list of modules from standard input. Convert the filenames into
 # absolute paths and compute the kernel release for each module (either using
 # the modinfo section or through the absolute path.
+# If used with input redirect, should be used as read_module_list < input,
+# not input | read_modules_list, the latter spawns a subshell
+# and the arrays are not seen in the caller
 read_modules_list() {
     local IFS=$'\n'
     modules=($(cat))
@@ -57,13 +104,7 @@ read_modules_list() {
         if [ ${modules[n]:0:1} != '/' ]; then
             modules[n]="$PWD/${modules[n]}"
         fi
-        if [ -f "${modules[n]}" ]; then
-            module_krels[n]=$(krel_of_module ${modules[n]})
-        else
-            # Try to extract the kernel release from the path
-            set -- "${modules[n]#*/lib/modules/}"
-            module_krels[n]=${1%%/*}
-        fi
+        module_krels["${modules[n]}"]=$(krel_of_module ${modules[n]})
     done
 }
 
@@ -146,7 +187,9 @@ compare_initramfs_modules() {
         # If the file lists are the same, compare each file to find any that changed
         for ((n = 0; n < ${#old_initramfs_modules[@]}; n++)); do
             if ! cmp "$tmpdir/old_initramfs/${old_initramfs_modules[n]}" \
-                     "$tmpdir/new_initramfs/${new_initramfs_modules[n]}" ; then
+                     "$tmpdir/new_initramfs/${new_initramfs_modules[n]}" \
+                     >/dev/null 2>&1
+            then
                 return 1
             fi
         done
@@ -171,7 +214,7 @@ check_initramfs() {
 
         $dracut -f "$tmp_initramfs" "$kernel"
 
-        if ! $(compare_initramfs_modules "$old_initramfs" "$tmp_initramfs");
+        if ! compare_initramfs_modules "$old_initramfs" "$tmp_initramfs";
         then
             doit mv "$tmp_initramfs" "$new_initramfs"
         else
@@ -180,84 +223,6 @@ check_initramfs() {
     fi
 }
 
-# krel_of_module:
-# Compute the kernel release of a module.
-krel_of_module() {
-    declare module=$1
-    /sbin/modinfo -F vermagic "$module" | awk '{print $1}'
-}
-
-# module_is_compatible:
-# Determine if a module is compatible with a particular kernel release. Also
-# include any symbol deps that might be introduced by other external kmods.
-module_is_compatible() {
-    declare module=$1 krel=$2 module_krel=$(krel_of_module "$module")
-
-    if [ ! -e "$tmpdir/all-symvers-$krel-$module_krel" ]; then
-        # Symbols exported by the "new" kernel
-        if [ ! -e $tmpdir/symvers-$krel ]; then
-            # Accept '.' in the symbol name to handle the .TOC. symbol on ppc
-            if [ -e /boot/symvers-$krel.gz ]; then
-                zcat /boot/symvers-$krel.gz \
-                | sed -r -ne 's:^(0x[0]*[0-9a-f]{8}\t[0-9a-zA-Z_.]+)\t.*:\1:p'
-            fi > $tmpdir/symvers-$krel
-        fi
-
-        # Symbols exported by the add-on modules of the "new" kernel
-        if [ ! -e "$tmpdir/addon-symvers-$krel" ]; then
-            if [ -e /lib/modules/$krel/extra ] && \
-               [ -n "`find /lib/modules/$krel/extra -type f`" ]; then
-                find /lib/modules/$krel/extra -name '*.ko' \
-                | xargs nm \
-                | sed -nre 's:^[0]*([0-9a-f]{8}) A __crc_(.*):0x\1 \2:p'
-            fi > $tmpdir/addon-symvers-$krel
-        fi
-
-        # Symbols that other add-on modules of the "old" kernel export
-        # (and that this module may require)
-        if [ ! -e "$tmpdir/extra-symvers-$module_krel" ]; then
-            if [ -e /lib/modules/$module_krel/extra ] && \
-	       [ -n "`find /lib/modules/$module_krel/extra -type f`" ]; then
-                find /lib/modules/$module_krel/extra -name '*.ko' \
-                | xargs nm \
-                | sed -nre 's:^[0]*([0-9a-f]{8}) A __crc_(.*):0x\1 \2:p'
-            fi > $tmpdir/extra-symvers-$module_krel
-        fi
-
-        sort -u $tmpdir/symvers-$krel \
-                $tmpdir/extra-symvers-$module_krel \
-                $tmpdir/addon-symvers-$krel \
-        > "$tmpdir/all-symvers-$krel-$module_krel"
-    fi
-
-    # If the module does not have modversions enabled, $tmpdir/modvers
-    # will be empty.
-    /sbin/modprobe --dump-modversions "$module" \
-    | sed -r -e 's:^(0x[0]*[0-9a-f]{8}\t.*):\1:' \
-    | sort -u \
-    > $tmpdir/modvers
-
-    # Only include lines of the second file in the output that don't
-    # match lines in the first file. (The default separator is
-    # <space>, so we are matching the whole line.)
-    join -j 1 -v 2 $tmpdir/all-symvers-$krel-$module_krel \
-                   $tmpdir/modvers > $tmpdir/join
-
-    if [ ! -s $tmpdir/modvers ]; then
-        echo "Warning: Module ${module##*/} from kernel $module_krel has no" \
-             "modversions, so it cannot be reused for kernel $krel" >&2
-    elif [ -s $tmpdir/join ]; then
-        [ -n "$verbose" ] &&
-        echo "Module ${module##*/} from kernel $module_krel is not compatible" \             "with kernel $krel in symbols:" $(sed -e 's:.* ::' $tmpdir/join)
-    else
-        [ -n "$verbose" ] &&
-        echo "Module ${module##*/} from kernel $module_krel is compatible" \
-             "with kernel $krel"
-        return 0
-    fi
-    return 1
-}
-
 usage() {
     echo "Usage: ${0##*/} [options] {--add-modules|--remove-modules}"
     echo "${0##*/} [options] {--add-kernel|--remove-kernel} {kernel-release}"
@@ -270,8 +235,7 @@ usage() {
 --remove-modules
         Remove compatibility symlinks from weak-updates/ directories
         for a list of modules.  The list of modules is read from
-        standard input. Optionally specify --delete-modules to
-        prevent weak-modules from attempting to locate any
+        standard input. Note: it doesn't attempt to locate any
         compatible modules to replace those being removed.
 
 --add-kernel
@@ -283,7 +247,7 @@ usage() {
         kernel.
 
 --no-initramfs
-	Do not generate an initramfs.
+        Do not generate an initramfs.
 
 --verbose
         Print the commands executed.
@@ -309,133 +273,423 @@ module_has_changed() {
 
 }
 
-# add_modules:
-# Read in a list of modules from stdinput and process them for compatibility
-# with installed kernels under /lib/modules.
-add_modules() {
+# module_weak_link:
+# Generate a weak link path for the module.
+# Takes module file name and the target kernel release as arguments
+# The way of generation intentionally left from the initial version
+module_weak_link() {
+    local module="$1"
+    local krel="$2"
+    local module_krel
+    local subpath
+
+    module_krel="$(krel_of_module "$module")"
+    subpath=$(echo $module | sed -nre "s:$BASEDIR(/usr)?/lib/modules/$module_krel/([^/]*)/(.*):\3:p")
+
+    echo "$BASEDIR/lib/modules/$krel/weak-updates/${subpath#/}"
+}
+
+# module_short_name:
+# 'basename' version purely in bash, cuts off path from the filename
+module_short_name() {
+    echo "${1##*/}"
+}
+
+#### Helper predicates
+
+# is_weak_for_module_valid:
+# Takes real module filename and target kernel as arguments.
+# Calculates weak symlink filename for the corresponding module
+# for the target kernel,
+# returns 'true' if the symlink filename is a symlink
+# and the symlink points to a readable file
+# EVEN if it points to a different filename
+is_weak_for_module_valid() {
+    local module="$1"
+    local krel="$2"
+    local weak_link
+
+    weak_link="$(module_weak_link $module $krel)"
+    [[ -L "$weak_link" ]] && [[ -r "$weak_link" ]]
+}
+
+# is_weak_link:
+# Takes a filename and a kernel release.
+# 'true' if the filename is symlink under weak-updates/ for the kernel.
+# It doesn't matter, if it's a valid symlink (points to a real file) or not.
+is_weak_link() {
+    local link="$1"
+    local krel="$2"
+
+    echo $link | grep -q "lib/modules/$krel/weak-updates" || return 1
+    [[ -L $link ]]
+}
+
+# is_extra_exists:
+# Takes a module filename, the module's kernel release and target kernel release.
+# The module filename should be a real, not a symlink, filename (i.e. in extra/).
+# Returns 'true' if the same module exists for the target kernel.
+is_extra_exists() {
+    local module="$1"
+    local module_krel="$2"
+    local krel="$3"
+    local subpath="${module#*/lib/modules/$module_krel/extra/}"
+
+    [[ -f $BASEDIR/lib/modules/$krel/extra/$subpath ]]
+}
+
+is_kernel_installed() {
+    local krel="$1"
+
+    [[ -f "$BASEDIR/boot/symvers-$krel.gz" ]]
+}
+
+#### Helpers
+
+# find_modules:
+# Takes kernel release and a list of subdirectories.
+# Produces list of module files in the subdirectories for the kernel
+find_modules() {
+    local krel="$1"
+    shift
+    local dirs="$*"
+
+    for dir in $dirs; do
+        find $BASEDIR/lib/modules/$krel/$dir -name '*.ko' 2>/dev/null
+    done
+}
+
+# find_installed_kernels:
+# Produces list of kernels, which modules are still installed
+find_installed_kernels() {
+    ls $BASEDIR/lib/modules/
+}
+
+# find_kernels_with_extra:
+# Produces list of kernels, where exists extra/ directory
+find_kernels_with_extra() {
+    local krel
+    local extra_dir
+
+    for krel in $(find_installed_kernels); do
+        extra_dir="$BASEDIR/lib/modules/$krel/extra"
+        [[ -d "$extra_dir" ]] || continue
+        echo "$krel"
+    done
+}
+
+# remove_weak_link_quiet:
+# Takes symlink filename and target kernel release.
+# Removes the symlink and the directory tree
+# if it was the last file in the tree
+remove_weak_link_quiet() {
+    local link="$1"
+    local krel="$2"
+    local subpath="${link#*/lib/modules/$krel/weak-updates}"
+
+    doit rm -f $link
+    ( cd "$BASEDIR/lib/modules/$krel/weak-updates" && \
+          doit rmdir --parents --ignore-fail-on-non-empty "$(dirname "${subpath#/}")" 2>/dev/null )
+}
+
+#### Main logic
+
+# update_modules_for_krel:
+# Takes kernel release and "action" function name.
+# Skips kernel without symvers,
+# otherwise triggers the main logic of modules installing/removing
+# for the given kernel, which is:
+# - save current state of weak modules symlinks
+# - install/remove the symlinks for the given (via stdin) list of modules
+# - validate the state and remove invalid symlinks
+#   (for the modules, which are not compatible (became incompatible) for
+#   the given kernel)
+# - check the state after validation to produce needed messages
+#   and trigger initrd regeneration if the list changed.
+update_modules_for_krel() {
+    local krel="$1"
+    local func="$2"
+
+    [[ -r "$BASEDIR/boot/symvers-$krel.gz" ]] || return
+
+    global_link_state_save $krel
+    $func $krel
+    validate_weak_links $krel
+    global_link_state_announce_changes $krel
+}
+
+# update_modules:
+# Common entry point for add/remove modules command
+# Takes the "action" function, the module list is supplied via stdin.
+# Reads the module list and triggers modules update for all installed
+# kernels.
+# Triggers initrd rebuild for the kernels, which modules are installed.
+update_modules() {
+    local func="$1"
+    local module_krel
+
     read_modules_list || exit 1
-    if [ ${#modules[@]} -gt 0 ]; then
-        for krel in $(ls /lib/modules/); do
-            [ -e "/boot/symvers-$krel.gz" ] || continue
-            for ((n = 0; n < ${#modules[@]}; n++)); do
-                module="${modules[n]}"
-                module_krel="${module_krels[n]}"
-                case "$module" in
-                /lib/modules/$krel/*)
-                    # Module was built against this kernel, update initramfs.
-                    module_has_changed $module $krel
-                    continue ;;
-                esac
-
-		# Module my also serve as a weak-update built against another
-		# kernel. We need to create symlinks for compatible kernels
-		# under /lib/modules and rerun depmod/dracut for those.
-
-                subpath=`echo $module | sed -nre "s:(/usr)?/lib/modules/$module_krel/([^/]*)/(.*):\3:p"`
-                weak_module="/lib/modules/$krel/weak-updates/${subpath#/}"
-                if [ -r "$weak_module" ]; then
-                    weak_krel=$(krel_of_module "$weak_module")
-                    if [ "$weak_krel" != "$module_krel" ] &&
-                       [ "$(printf "%s\n" "$weak_krel" "$module_krel" \
-                            | rpmsort | (read input; echo "$input"; \
-                                         while read input; do true; done))" = \
-                         "$module_krel" ]; then
-                        # Keep modules from more recent kernels.
-                        [ -n "$verbose" ] && echo \
-"Keeping module ${module##*/} from kernel $weak_krel for kernel $krel"
-                        continue
-                    fi
-                fi
-                if module_is_compatible $module $krel; then
-                    doit mkdir -p $(dirname $weak_module)
-                    doit ln -sf $module $weak_module
-                    # Module was built against another kernel, update initramfs.
-                    module_has_changed $module $krel
-                fi
-            done
-        done
+    [[ ${#modules[@]} -gt 0 ]] || return
+
+    for krel in $(find_installed_kernels); do
+        update_modules_for_krel $krel $func
+    done
+
+    for module in "${modules[@]}"; do
+        # Module was built against this kernel, update initramfs.
+        module_krel="${module_krels[$module]}"
+        module_has_changed $module $module_krel
+    done
+}
+
+# add_weak_links:
+# Action function for the "add-modules" command
+# Takes the kernel release, where the modules are added
+# and the modules[] and module_krels[] global arrays.
+# Install symlinks for the kernel with minimal checks
+# (just filename checks, no symbol checks)
+add_weak_links() {
+    local krel="$1"
+    local module_krel
+    local weak_link
+
+    for module in "${modules[@]}"; do
+        module_krel="$(krel_of_module $module)"
+
+        [[ "$module_krel" == "$krel" ]] && continue
+
+        if is_extra_exists $module $module_krel $krel; then
+            pr_verbose "found $(module_short_name $module) for $krel while installing for $module_krel, update case?"
+        fi
+
+        if is_weak_for_module_valid $module $krel; then
+            pr_verbose "weak module for $(module_short_name $module) already exists for kernel $krel, update case?"
+            # we should update initrd in update case,
+            # the change is not seen by the symlink detector
+            # (global_link_state_announce_changes())
+            module_has_changed $module $krel
+        fi
+
+        weak_link="$(module_weak_link $module $krel)"
+
+        doit mkdir -p "$(dirname $weak_link)"
+        doit ln -sf $module $weak_link
+
+    done
+}
+
+# remove_weak_links:
+# Action function for the "remove-modules" command
+# Takes the kernel release, where the modules are removed
+# and the modules[] and module_krels[] global arrays.
+# Removes symlinks from the given kernel if they are installed
+# for the modules in the list.
+remove_weak_links() {
+    local krel="$1"
+    local weak_link
+    local target
+    local module_krel
+
+    for module in "${modules[@]}"; do
+        module_krel="$(krel_of_module $module)"
+
+        [[ "$module_krel" == "$krel" ]] && continue
+
+        weak_link="$(module_weak_link $module $krel)"
+        target="$(readlink $weak_link)"
+
+        if [[ "$module" != "$target" ]]; then
+            pr_verbose "Skipping symlink $weak_link"
+            continue
+        fi
+        # In update case the --remove-modules call is performed
+        # after --add-modules (from postuninstall).
+        # So, we shouldn't really remove the symlink in this case.
+        # But in the remove case the actual target already removed.
+        if ! is_weak_for_module_valid "$module" "$krel"; then
+            remove_weak_link_quiet "$weak_link" "$krel"
+        fi
+    done
+}
+
+# validate_weak_links:
+# Takes kernel release.
+# Checks if all the weak symlinks are suitable for the given kernel.
+# Uses depmod to perform the actual symbol checks and parses the output.
+# Since depmod internally creates the module list in the beginning of its work
+# accroding to the priority list in its configuration, but without symbol
+# check and doesn't amend the list during the check, the function runs it
+# in a loop in which it removes discovered incompatible symlinks
+validate_weak_links() {
+    local krel="$1"
+    local basedir=${BASEDIR:+-b $BASEDIR}
+    local tmp
+    declare -A symbols
+    local is_updates_changed=1
+    local module
+    local module_krel
+    local target
+    local modpath
+    local symbol
+    local weak_link
+
+    tmp=$(mktemp -p $tmpdir)
+
+    if ! [[ -e $tmpdir/symvers-$krel ]]; then
+        [[ -e $BASEDIR/boot/symvers-$krel.gz ]] || return
+        zcat $BASEDIR/boot/symvers-$krel.gz > $tmpdir/symvers-$krel
     fi
+
+    while ((is_updates_changed)); do
+        is_updates_changed=0
+
+        # again $tmp because of subshell, see read_modules_list() comment
+        # create incompatibility report by depmod
+        /sbin/depmod $basedir -aeE $tmpdir/symvers-$krel -e $krel >$tmp 2>&1
+        # parse it into symbols[] associative array in form a-la
+        #   symbols["/path/to/the/module"]="list of bad symbols"
+        while read line; do
+            set -- $(echo $line | awk '/needs unknown symbol/{print $3 " " $NF}')
+            modpath=$1
+            symbol=$2
+            if [[ -n "$modpath" ]]; then
+                symbols[$modpath]="${symbols[$modpath]} $symbol"
+                continue
+            fi
+
+            set -- $(echo $line | awk '/disagrees about version of symbol/{print $3 " " $NF}')
+            modpath=$1
+            symbol=$2
+            if [[ -n "$modpath" ]]; then
+                symbols[$modpath]="${symbols[$modpath]} $symbol"
+                continue
+            fi
+        done < $tmp
+
+        # loop through all the weak links from the list of incompatible
+        # modules and remove them. Skips non-weak incompatibilities
+        for modpath in "${!symbols[@]}"; do
+            is_weak_link $modpath $krel || continue
+
+            target=$(readlink $modpath)
+            module_krel=$(krel_of_module $target)
+
+            remove_weak_link_quiet "$modpath" "$krel"
+
+            pr_verbose "Module $(module_short_name $modpath) from kernel $module_krel is not compatible with kernel $krel in symbols: ${symbols[$modpath]}"
+            is_updates_changed=1
+        done
+    done
+    rm -f $tmp
+
+    # this loop is just to produce verbose compatibility messages
+    # for the compatible modules
+    for module in "${modules[@]}"; do
+        is_weak_for_module_valid $module $krel || continue
+
+        weak_link="$(module_weak_link $module $krel)"
+        target="$(readlink $weak_link)"
+        module_krel=$(krel_of_module $target)
+
+        if [[ "$module" == "$target" ]]; then
+            pr_verbose "Module ${module##*/} from kernel $module_krel is compatible with kernel $krel"
+        fi
+    done
+}
+
+# global_link_state_save:
+# Takes kernel release
+# Saves the given kernel's weak symlinks state into the global array
+# weak_modules_before[] for later processing
+global_link_state_save() {
+    local krel="$1"
+    local link
+    local target
+
+    weak_modules_before=()
+    for link in $(find_modules $krel weak-updates | xargs); do
+        target=$(readlink $link)
+        weak_modules_before[$link]=$target
+    done
+}
+
+# global_link_state_announce_changes:
+# Takes kernel release
+# Reads the given kernel's weak symlinks state, compares to the saved,
+# triggers initrd rebuild if there were changes
+# and produces message on symlink removal
+global_link_state_announce_changes() {
+    local krel="$1"
+    local link
+    local target
+    local new_target
+    declare -A weak_modules_after
+
+    for link in $(find_modules $krel weak-updates | xargs); do
+        target=${weak_modules_before[$link]}
+        new_target=$(readlink $link)
+        weak_modules_after[$link]=$new_target
+
+        # report change of existing link and appearing of a new link
+        [[ "$target" == "$new_target" ]] || module_has_changed $new_target $krel
+    done
+
+    for link in "${!weak_modules_before[@]}"; do
+        target=${weak_modules_before[$link]}
+        new_target=${weak_modules_after[$link]}
+
+        # report change of existing link and disappearing of an old link
+        [[ "$target" == "$new_target" ]] && continue
+        module_has_changed $target $krel
+        [[ -n "$new_target" ]] ||
+            pr_verbose "Removing compatible module $(module_short_name $target) from kernel $krel"
+    done
 }
 
 # remove_modules:
 # Read in a list of modules from stdinput and process them for removal.
-# Parameter is noreplace to delete modules, otherwise link compat.
+# Parameter (noreplace) is deprecated, acts always as "noreplace".
+# There is no sense in the "replace" functionality since according
+# to the current requirements RPM will track existing of only one version
+# of extra/ module (no same extra/ modules for different kernels).
 remove_modules() {
-    delete_modules=${1:-replace}
+    update_modules remove_weak_links
+}
 
-    read_modules_list || exit 1
-    if [ ${#modules[@]} -gt 0 ]; then
-
-	# Hunt for all known users of this module in /lib/modules, remove them
-	# and create symlinks to other compatible modules (downgrade) if
-	# possible, update initramfs for each modified kernel too.
-
-        krels=($(ls /lib/modules/ | rpmsort -r))
-        for krel in "${krels[@]}"; do
-            [ -e "/boot/symvers-$krel.gz" ] || continue
-            for ((n = 0; n < ${#modules[@]}; n++)); do
-                module="${modules[n]}"
-                module_krel="${module_krels[n]}"
-
-		# Module is going to be removed, update initramfs.
-		module_has_changed $module $krel
-
-                subpath="${module#*/lib/modules/$module_krel/extra}"
-                weak_module="/lib/modules/$krel/weak-updates/${subpath#/}"
-                if [ "$module" == "`readlink $weak_module`" ]; then
-                    [ -n "$verbose" ] && echo \
-"Removing compatible module ${module##*/} from kernel $krel"
-                    doit rm -f "$weak_module"
-                    if [ "replace" == "$delete_modules" ]; then
-                        for krel2 in "${krels[@]}"; do
-                            if [ $krel2 != $krel ]; then
-                                module="/lib/modules/$krel2/extra/${subpath#/}"
-                                [ -e "$module" ] || continue
-                                if module_is_compatible "$module" "$krel"; then
-                                    [ -n "$verbose" ] && echo \
-"Adding compatible module ${module##*/} from kernel $krel2 instead"
-                                    doit ln -s "$module" "$weak_module"
-			            module_has_changed $module $krel
-                                    break
-                                fi
-                            fi
-                        done
-                    fi
-                    # Remove the part of the directory beneath weak-updates
-                    ( cd "/lib/modules/$krel/weak-updates" && \
-                        doit rmdir --parents --ignore-fail-on-non-empty "$(dirname "${subpath#/}")" )
-                fi
-            done
-        done
-    fi
+# add_modules:
+# Read in a list of modules from stdinput and process them for compatibility
+# with installed kernels under /lib/modules.
+add_modules() {
+    update_modules add_weak_links
 }
 
 add_kernel() {
-    add_krel=${1:-$(uname -r)}
-    if [ ! -e "/boot/symvers-$add_krel.gz" ]; then
-        echo "Symvers dump file /boot/symvers-$add_krel.gz" \
+    local krel=${1:-$(uname -r)}
+    local tmp
+
+    tmp=$(mktemp -p $tmpdir)
+
+    if [ ! -e "$BASEDIR/boot/symvers-$krel.gz" ]; then
+        echo "Symvers dump file $BASEDIR/boot/symvers-$krel.gz" \
              "not found" >&2
         exit 1
     fi
-    for krel in $(ls /lib/modules/ | rpmsort -r); do
-        [ "$add_krel" = "$krel" ] && continue
-        [ -d /lib/modules/$krel/extra ] || continue
-        for module in $(find /lib/modules/$krel/extra -name '*.ko'); do
-            subpath="${module#*/lib/modules/$krel/extra}"
-            weak_module="/lib/modules/$add_krel/weak-updates/${subpath#/}"
-            [ -e "$weak_module" ] && continue
-            if module_is_compatible $module $add_krel; then
-		module_has_changed $module $add_krel
-                doit mkdir -p $(dirname $weak_module)
-                doit ln -sf $module $weak_module
-            fi
-        done
+
+    for k in $(find_kernels_with_extra | rpmsort -r); do
+        [[ "$krel" == "$k" ]] && continue
+        find_modules $k extra >> $tmp
     done
+
+    # to avoid subshell, see the read_modules_list comment
+    read_modules_list < $tmp
+    rm -f $tmp
+
+    update_modules_for_krel $krel add_weak_links
 }
 
 remove_kernel() {
     remove_krel=${1:-$(uname -r)}
-    weak_modules="/lib/modules/$remove_krel/weak-updates"
+    weak_modules="$BASEDIR/lib/modules/$remove_krel/weak-updates"
     module_has_changed $weak_modules $remove_krel
 
     # Remove everything beneath the weak-updates directory
@@ -448,7 +702,8 @@ remove_kernel() {
 
 options=`getopt -o h --long help,add-modules,remove-modules \
                      --long add-kernel,remove-kernel \
-                     --long dry-run,no-initramfs,verbose,delete-modules -- "$@"`
+                     --long dry-run,no-initramfs,verbose,delete-modules \
+                     --long basedir:,dracut:,check-initramfs-prog: -- "$@"`
 
 [ $? -eq 0 ] || usage 1
 
@@ -478,7 +733,19 @@ while :; do
         verbose=1
         ;;
     --delete-modules)
-        do_delete_modules=1
+        pr_warning "--delete-modules is deprecated, no effect"
+        ;;
+    --basedir)
+        BASEDIR="$2"
+        shift
+        ;;
+    --dracut)
+        dracut="$2"
+        shift
+        ;;
+    --check-initramfs-prog)
+        CHECK_INITRAMFS="$2"
+        shift
         ;;
     -h|--help)
         usage 0
@@ -491,27 +758,31 @@ while :; do
     shift
 done
 
+if [ ! -x "$dracut" ]
+then
+    echo "weak-modules: this tool requires a dracut-enabled kernel"
+    exit 1
+fi
+
+initramfs_prefix="$BASEDIR/${default_initramfs_prefix#/}"
+
 if [ -n "$do_add_modules" ]; then
-	add_modules
+    add_modules
 
 elif [ -n "$do_remove_modules" ]; then
-        if [ -n "$do_delete_modules" ]; then
-            remove_modules "noreplace"
-        else
-	    remove_modules
-        fi
+    remove_modules
 
 elif [ -n "$do_add_kernel" ]; then
-	kernel=${1:-$(uname -r)}
-	add_kernel $kernel
+    kernel=${1:-$(uname -r)}
+    add_kernel $kernel
 
 elif [ -n "$do_remove_kernel" ]; then
-	kernel=${1:-$(uname -r)}
-	remove_kernel $kernel
+    kernel=${1:-$(uname -r)}
+    remove_kernel $kernel
 
-	exit 0
+    exit 0
 else
-	usage 1
+    usage 1
 fi
 
 ################################################################################
@@ -521,14 +792,19 @@ fi
 # run depmod and dracut as needed
 for krel in ${!changed_modules_*}; do
     krel=${!krel}
+    basedir=${BASEDIR:+-b $BASEDIR}
 
-    doit /sbin/depmod -ae -F /boot/System.map-$krel $krel
+    if is_kernel_installed $krel; then
+        doit /sbin/depmod $basedir -ae -F $BASEDIR/boot/System.map-$krel $krel
+    else
+        pr_verbose "Skipping depmod for non-installed kernel $krel"
+    fi
 done
 
 for krel in ${!changed_initramfs_*}; do
     krel=${!krel}
 
     if [ ! -n "$no_initramfs" ]; then
-        check_initramfs $krel
+        ${CHECK_INITRAMFS:-check_initramfs} $krel
     fi
 done
diff --git a/SPECS/kmod.spec b/SPECS/kmod.spec
index 74775df..70fbf01 100644
--- a/SPECS/kmod.spec
+++ b/SPECS/kmod.spec
@@ -1,6 +1,6 @@
 Name:		kmod
 Version:	20
-Release:	9%{?dist}
+Release:	15%{?dist}
 Summary:	Linux kernel module management utilities
 
 Group:		System Environment/Kernel
@@ -13,9 +13,9 @@ Exclusiveos:	Linux
 
 BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
 
-Patch01:	kmod-%{version}-%{release}-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch
-Patch02:	kmod-%{version}-%{release}-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch
-Patch03:	kmod-%{version}-%{release}-0003-libkmod-Handle-long-lines-in-proc-modules.patch
+Patch01:	kmod-0001-depmod-Don-t-fall-back-to-uname-on-bad-version.patch
+Patch02:	kmod-0002-depmod-Ignore-PowerPC64-ABIv2-.TOC.-symbol.patch
+Patch03:	kmod-0003-libkmod-Handle-long-lines-in-proc-modules.patch
 
 BuildRequires:	chrpath
 BuildRequires:	zlib-devel
@@ -128,6 +128,43 @@ install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/depmod.d/dist.conf
 %{_libdir}/libkmod.so
 
 %changelog
+* Fri May 12 2017 Yauheni Kaliuta <ykaliuta@redhat.com> - 20-15
+- weak-modules: install weak link even if there is same name in extra.
+  Resolves: rhbz#1450003
+
+* Fri May  5 2017 Yauheni Kaliuta <ykaliuta@redhat.com> - 20-14
+- weak-modules: check if kernel installed for the final depmod.
+  Resolves: rhbz#1448349
+
+* Mon Mar 27 2017 Yauheni Kaliuta <ykaliuta@redhat.com> - 20-13
+- Remove kmod-20.tar from sources, kmod-20.tar.xz is used.
+  Resolves: rhbz#1434319
+
+* Tue Feb 21 2017 Yauheni Kaliuta <ykaliuta@redhat.com> - 20-12
+- weak-modules: fix coverity introduced by latest changes
+- weak-modules: fix "permission denied" on some upgrades.
+  Resolves: rhbz#1416566
+
+* Thu Feb 16 2017 Yauheni Kaliuta <ykaliuta@redhat.com> - 20-11
+- Rebuild package with updated rpm macros.
+  Resolves: rhbz#1420768
+
+* Thu Feb  2 2017 Tony Camuso <tcamuso@redhat.com> - 20-10
+- Rename patches so they are not specific to the build. This was
+  causing problems with z-stream builds.
+  Resolves: rhbz#1416498
+
+* Mon Nov 28 2016 Yauheni Kaliuta <ykaliuta@redhat.com> - 20-10
+- weak-modules: deprecate --delete-modules switch.
+- weak-modules: implement some pathes configuration from cmdline.
+- weak-modules: redesign to reuse depmod -aeE functionality
+  (with some preparation changes).
+  This is an updated version of the script which doesn't support
+  multiple installation of the same out-of-tree module (stored in the
+  'extra' subdirectory). But it more correctly checks dependencies
+  between the modules.
+  Resolves: rhbz#1367942
+
 * Fri Sep  2 2016 Tony Camuso <tcamuso@redhat.com> - 20-9
 - Must be bumped to 20-9 due to changes and version bumps in the
   7.2-z stream.